import createFactory from './create-factory';
import mapShape from './map-shape';
import setDisplayName from './set-display-name';
import validateShapeMap from './validate-shape-map';
import wrapDisplayName from './wrap-display-name';

var shapeFrom = function shapeFrom(pathMap) {
  var mapper = mapShape(pathMap);

  return function (BaseComponent) {
    var factory = createFactory(BaseComponent);

    var ShapeFrom = function ShapeFrom(props) {
      return factory(mapper(props));
    };

    if (process.env.NODE_ENV !== 'production') {
      return setDisplayName(wrapDisplayName(BaseComponent, 'shapeFrom'))(ShapeFrom);
    }

    return ShapeFrom;
  };
};

export default validateShapeMap(shapeFrom);