'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createFactory = require('./create-factory');

var _createFactory2 = _interopRequireDefault(_createFactory);

var _mapShape = require('./map-shape');

var _mapShape2 = _interopRequireDefault(_mapShape);

var _setDisplayName = require('./set-display-name');

var _setDisplayName2 = _interopRequireDefault(_setDisplayName);

var _validateShapeMap = require('./validate-shape-map');

var _validateShapeMap2 = _interopRequireDefault(_validateShapeMap);

var _wrapDisplayName = require('./wrap-display-name');

var _wrapDisplayName2 = _interopRequireDefault(_wrapDisplayName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shapeFrom = function shapeFrom(pathMap) {
  var mapper = (0, _mapShape2.default)(pathMap);

  return function (BaseComponent) {
    var factory = (0, _createFactory2.default)(BaseComponent);

    var ShapeFrom = function ShapeFrom(props) {
      return factory(mapper(props));
    };

    if (process.env.NODE_ENV !== 'production') {
      return (0, _setDisplayName2.default)((0, _wrapDisplayName2.default)(BaseComponent, 'shapeFrom'))(ShapeFrom);
    }

    return ShapeFrom;
  };
};

exports.default = (0, _validateShapeMap2.default)(shapeFrom);